///// MatrixGrid.java /////
/**
 * Matrix Limits. Shows cell's limit.
 * @author Jesus Márquez Barrera
 */

import java.awt.*;
import java.awt.event.*;
import java.awt.geom.*;


public class MatrixGrid{

	private int x,y,tlx,tly,cw;
   	private Color color;
  	private Path2D.Double grid;

	public MatrixGrid(Matrix matrix){
		y=matrix.getYCellShown();
		x=matrix.getXCellShown();
		tlx=matrix.getTopLeftX();
		tly=matrix.getTopLeftY();
		cw=matrix.getCellShownSize();
		color= Color.GRAY;
		grid = new Path2D.Double();
		for(int i=0;i<=y;i++){
			grid.moveTo(tlx,tly+i*cw);
			grid.lineTo(tlx+x*cw,tly+i*cw);
		}

		for(int j=0;j<=x;j++){
			grid.moveTo(tlx+j*cw,tly);
			grid.lineTo(tlx+j*cw,tly+y*cw);
		}		
	}

	public void draw(Graphics2D g){
		g.setColor(color);
		g.draw(grid);
	}
}