import javax.swing.JPanel;
import java.awt.event.*;
import java.awt.event.MouseAdapter;
import java.awt.*;
import java.awt.geom.Point2D;

public class MouseListener extends MouseAdapter {
	private Matrix matrix;
    private ElectricalElement selectedElement;
    private Point pos;
    private boolean ocuped;
    
    //constructor
    public MouseListener(Matrix m){
        matrix = m;//variable del entorno
        selectedElement = null;
        pos = new Point(0,0);
        ocuped = false;
    }

    public void mouseClicked(MouseEvent e){
    	pos = e.getPoint();
   		//maquina de estados para agregar o seleccionar
   		//si se selecciona, implementar desplazamiento por el glass
   		//sino, mover elemento de casilla en la matrix
   		pos = matrix.getShownMatrixIndex(pos);

		ocuped = (matrix.getShownMatrix()[(int)pos.getY()][(int)pos.getX()].getMyElement() != null);

    	if(selectedElement == null){
    		if(ocuped){
    			selectedElement = (matrix.getShownMatrix()[(int)pos.getY()][(int)pos.getX()].getMyElement());
    			selectedElement.setSelected(true);
    			matrix.getView().repaint();
    		}
    	}
    	else{
    		switch
    		if(!ocuped){
    			matrix.getShownMatrix()[(int)pos.getY()][(int)pos.getX()].setMyElement(/*agregar mierda aqui*/);
    			selectedElement.setSelected(false);
    			selectedElement = null;
    			matrix.getView().repaint();
    		}
    	}
    }

/*    public void mouseMoved(MouseEvent e){
    	//verificar si se tiene un elemento seleccionado
    	//si, entonces implementar movimiento por el glass
    	//sino, no implementar

    }*/

    //////////////////////////////////////////////////////////////////
    // agregar metodo en la clase matrix para convertir el pixel 	//
    // de el screen a una casilla de la matrixshown.				//
    // agregar metodo que convierta una casilla de la matrixshow a  //
    // una casilla de la matrix completa. Check						//
    //////////////////////////////////////////////////////////////////
}